from Products.Archetypes.atapi import *
from Products.MyTitleLess.config import PROJECTNAME
from string import join

schema = BaseSchema.copy() + Schema((
    FileField('File', required = 1,),
   StringField(name='Maturity', required=1,
        vocabulary=['Alpha (a)', 'Beta (b)', 'Stable (s)'],
        widget=SelectionWidget(label='Release Maturity',),
    ),
    IntegerField('Version', required = 1, ),
))

# the title can not be edited
schema['title'].required = 0
schema['title'].widget.visible = {'edit':'invisible', 'view': 'invisible'}

class MyTitleLess(BaseContent):
    """An Archetype for MyTitleLess application"""

    schema = schema
    _at_rename_after_creation = True

    def setVersion(self, value):
        """When we set the version update title."""
        self.Schema()['Version'].set(self, value)

        filename = self.getField('File').get(self).filename

        try:
            filestart = filename.split('.')[0]
        except:
            filestart = filename

        try:
            fileend = '.' + join(filename.split('.')[1:],'.')
        except:
            fileend = ''

        #TODO/XXX: this could be a bit more beautiful
        maturity = self.getField('Maturity').get(self)
        try:
            maturity = maturity.split('(')[-1].split(')')[0]
        except:
            maturity = ''

        version = self.getField('Version').get(self)

        new_title = "%s-%s%s%s" % (filestart, maturity, version, fileend)
        # new_title = "%s %s%s" % (filename, maturity, version)
        self.setTitle(new_title)

registerType(MyTitleLess, PROJECTNAME)
